Subject: Multiple validations will append to list of errors instead of replacing list from last validation
Description

If I validate several objects one after the other and then call getErrors() the listed errors will be the set union of all errors in the
different single validation processes.

This does not agree with the comments found in

Classes/Validation/Validator/ValidatorInterface.php

which state

[...]
        /**
         * Checks if the given value is valid according to the validator.
         *
         * If at least one error occurred, the result is FALSE and any errors can
         * be retrieved through the getErrors() method.
         *
         * Note that all implementations of this method should set $this->errors() to an
         * empty array before validating.
         *
         * @param mixed $value The value that should be validated
         * @return boolean TRUE if the value is valid, FALSE if an error occured
         * @api
         */
        public function isValid($value);
[...]
        /**
         * Returns an array of errors which occurred during the last isValid() call.
         *
         * @return array An array of \F3\FLOW3\Validation\Error objects or an empty array if no errors occurred.
         * @api
         */
        public function getErrors();
[...]

A piece of code like

$validator = $this->validatorResolver->getBaseValidatorConjunction('F3\Foo\Domain\Model\Bar');
if ($validator->isValid($fooBarObject)) {
} else {
 $errorMessages = '';
 foreach ($validator->getErrors() as $error) {
  $errorMessages .= $error->getPropertyName().', ';
 }
}

will not give the errors for the last instance of $fooBarObject that was validated but instead the set union of errors from all instances
validated up to this point. In other words, if in the first instance the property "abc" id not validate and in the second instance the
property "bla" didn't validate, the error lists will be

instance 1: abc,
instance 2: abc,bla,

instead of

instance 1: abc,
instance 2: bla,

Associated revisions
Revision 461b47f2 - 2010-08-06 17:07 - Karsten Dambekalns

[+BUGFIX] FLOW3 (Validation): Some validators did not reset stale errors on isValid() calls, fixes #8558.

History
#1 - 2010-06-30 03:24 - Christian Lerrahn

Oops. That target version obviously doesn't make much sense... :( Please correct! :)

#2 - 2010-07-01 08:42 - Christian Lerrahn
- File clear-errors-patch.diff added

The isValid() methods of

F3\FLOW3\Validation\Validator\GenericObjectValidator

and

F3\FLOW3\Validation\Validator\ConjunctionValidator

do not reset $this->errors.

Attached patch clears $this->errors at beginning of isValid() method in these objects.

#3 - 2010-07-15 17:55 - Karsten Dambekalns
- Category changed from Error to Validation
- Status changed from New to Accepted
- Assigned To set to Karsten Dambekalns
- Target version changed from 183 to 1.0 alpha 11
- Start date deleted (2010-06-30)

Thanks for adding this here, was about to reply on your (old) email and remembered having seen this today...

#4 - 2010-08-05 09:40 - Christian Lerrahn

Are there any new developments on this? This is a bit of a show stopper for our project. :(

Does my patch make sense?

#5 - 2010-08-06 13:42 - Karsten Dambekalns
- Start date set to 2010-08-06
- Estimated time set to 2.00

Working on this, expect fix in SVN today. Some more validators miss the reset and of course we need to add an unit test for all validators...

#6 - 2010-08-06 15:30 - Karsten Dambekalns
- Status changed from Accepted to Resolved
- % Done changed from 0 to 100

Applied in changeset r4948.

Files
clear-errors-patch.diff 1.2 kB 2010-07-01 Christian Lerrahn
